-- SIMAnswers
-- Copyright 2010-2012 by Mike Feng Jinglong. Distribution is strictly prohibited!
-- License: SIMBunch
--
-- SIMAnswers table(s) definition
--
--
CREATE TABLE IF NOT EXISTS `#__simanswers_config` (
	`id` int NOT NULL auto_increment,
	`sitename` varchar(100) NOT NULL default '',
	`nametype` varchar(10) NOT NULL default 'name',
	`perpage` int NOT NULL default 15,
	`expiration` int NOT NULL default 4,
	`extend` int NOT NULL default 4,
	`leadtime` int NOT NULL default 4,
	`qnmaxlength` int NOT NULL default 100,
	`commentmaxlength` int NOT NULL default 300,
	`minlength` int NOT NULL default 10,
	`voteslead` int NOT NULL default 2,
	`twitter` varchar(100) NOT NULL default 'simbunch',
	`adminemails` varchar(100) NOT NULL default 'adminemail@yoursite.com',
	`points` varchar(255) NOT NULL default '{"participation":100,"login":1,"choosebest":3,"answer":2,"vote":1,"bestanswer":10,"thumbsup":1,"ask":5,"removed":2}',

	`enablelevels` tinyint NOT NULL default 1,
	`level1` varchar(255) NOT NULL default '{"pts":0,	"qns":5,	"ans":20,	"cmts":10,	"stars":10,		"ratings":0,	"votes":20}',
	`level2` varchar(255) NOT NULL default '{"pts":150,	"qns":10,	"ans":40,	"cmts":20,	"stars":100,	"ratings":"*",	"votes":40}',
	`level3` varchar(255) NOT NULL default '{"pts":300,	"qns":15,	"ans":60,	"cmts":30,	"stars":100,	"ratings":"*",	"votes":60}',
	`level4` varchar(255) NOT NULL default '{"pts":450,	"qns":20,	"ans":80,	"cmts":40,	"stars":100,	"ratings":"*",	"votes":80}',
	`level5` varchar(255) NOT NULL default '{"pts":600,	"qns":"*",	"ans":"*",	"cmts":"*",	"stars":100,	"ratings":"*",	"votes":80}',
	`level6` varchar(255) NOT NULL default '{"pts":750,	"qns":"*",	"ans":"*",	"cmts":"*",	"stars":100,	"ratings":"*",	"votes":100}',
	`level7` varchar(255) NOT NULL default '{"pts":900,	"qns":"*",	"ans":"*",	"cmts":"*",	"stars":100,	"ratings":"*",	"votes":100}',

	`ask_gid` tinyint(4) NOT NULL default 18,
	`answer_gid` tinyint(4) NOT NULL default 18,
	`comment_gid` tinyint(4) NOT NULL default 18,
	`rate_gid` tinyint(4) NOT NULL default 18,
	`vote_gid` tinyint(4) NOT NULL default 18,
	
	`mailfrom` varchar(50) NOT NULL default '',
	`fromname` varchar(80) NOT NULL default 'SIMBunch',
	`emailsubject` varchar(80) NOT NULL default 'SIMBunch Answers',
	`emailbody` text NOT NULL default '',

	`guidelines` text NOT NULL default '',
	`howitworks` text NOT NULL default '',

	`emailimport` tinyint(4) NOT NULL default 1,
	`listedemails` text NOT NULL default '',

	`jsactivities` varchar(255) NOT NULL default '{}',

	`licensekey` varchar(40) default '',
	PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__simanswers_categories` (
	`id` int(11) NOT NULL auto_increment,
	`parent` int(11) NOT NULL default 0,
	`name` varchar(255) NOT NULL default '',
	`description` text NOT NULL,
	`ordering` int(11) NOT NULL default 1,
	`published` int(11) NOT NULL default 1,
	PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__simanswers_questions` (
	`qid` int(11) NOT NULL auto_increment,
	`catid` int(11) NOT NULL default 0,
	`creator` int(11) NOT NULL default 0,
	`title` text NOT NULL default '',
	`details` text NOT NULL default '',
	`cdate` int(11) NOT NULL default 0,
	`notify` tinyint(4) NOT NULL default 0,
	`expiration` int(11) NOT NULL default 0,
	`extended` tinyint(4) NOT NULL default 0,
	`put_to_vote` tinyint(4) NOT NULL default 0,
	`resolved` tinyint(4) NOT NULL default 0,
	`tinyurl` varchar(50) NOT NULL default '',
	PRIMARY KEY  (`qid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__simanswers_additional_details` (
	`additional_to` int(11) NOT NULL default 0,
	`details` text NOT NULL default '',
	`cdate` int(11) NOT NULL default 0
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__simanswers_answers` (
	`aid` int(11) NOT NULL auto_increment,
	`qid` int(11) NOT NULL default 0,
	`creator` int(11) NOT NULL default 0,
	`answer` text NOT NULL default '',
	`sources` text NOT NULL default '',
	`cdate` int(11) NOT NULL default 0,
	`best` tinyint(4) NOT NULL default 0,
	`best_rating` tinyint(4) NOT NULL default 0,
	`feedback` text NOT NULL default '',
	PRIMARY KEY  (`aid`),
	UNIQUE KEY (`qid`, `creator`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__simanswers_thumbs` (
	`aid` int(11) NOT NULL default 0,
	`uid` int(11) NOT NULL default 0,
	`direction` varchar(5) NOT NULL default 0,
	`cdate` int(11) NOT NULL default 0,
	UNIQUE KEY (`aid`, `uid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__simanswers_comments` (
	`cmtid` int(11) NOT NULL auto_increment,
	`uid` int(11) NOT NULL default 0,
	`qid` int(11) NOT NULL default 0,
	`cdate` int(11) NOT NULL default 0,
	`comment` text NOT NULL default '',
	PRIMARY KEY  (`cmtid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__simanswers_votes` (
	`qid` int(11) NOT NULL default 0,
	`aid` int(11) NOT NULL default 0,
	`uid` int(11) NOT NULL default 0,
	UNIQUE KEY (`qid`, `uid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__simanswers_stars` (
	`qid` int(11) NOT NULL default 0,
	`uid` int(11) NOT NULL default 0,
	`cdate` int(11) NOT NULL default 0,
	UNIQUE KEY (`qid`, `uid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__simanswers_watchlists` (
	`qid` int(11) NOT NULL default 0,
	`uid` int(11) NOT NULL default 0,
	`cdate` int(11) NOT NULL default 0,
	UNIQUE KEY (`qid`, `uid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__simanswers_users` (
	`uid` int(11) NOT NULL default 0,
	`nicktype` varchar(15) NOT NULL default 'default',
	`nickname` varchar(50) NOT NULL default '',
	`avatar` varchar(50) NOT NULL default '',
	`profile_link` tinyint(4) NOT NULL default 1,
	`hide_qna` tinyint(4) NOT NULL default 0,
	`email_new_answer` tinyint(4) NOT NULL default 1,
	`email_friend` tinyint(4) NOT NULL default 1,
	`about_me` text NOT NULL default '',
	UNIQUE KEY (`uid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__simanswers_points` (
	`pid` int(11) NOT NULL auto_increment,
	`uid` int(11) NOT NULL default 0,
	`qid` int(11) NOT NULL default 0,
	`points` int(11) NOT NULL default 100,
	`cdate` int(11) NOT NULL default 0,
	`reason` varchar(255) NOT NULL default '',
	PRIMARY KEY (`pid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__simanswers_violations` (
	`id` int(11) NOT NULL auto_increment,
	`uid` int(11) NOT NULL default 0,
	`cid` int(11) NOT NULL default 0,
	`type` varchar(50) NOT NULL default '',
	`reason` tinyint(4) NOT NULL default 0,
	`additional_details` text NOT NULL default '',
	PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;