<?php
/**
// Copyright (C) 2010 - 2012 Mike Feng Jinglong
//
// This program is a commercial software; you cannot redistribute it
// and/or modify it without the explicit consent from the author.
//
// All title and copyright in and to the Product is owned by Mike Feng
// and is protected by international copyright laws and treaty provisions.
// Mike Feng retains all ownership rights in the Product.
// The copyright notice must be reproduced and included on any copy
// that is expressly permitted under this Agreement.
**/

// no direct access
defined('_JEXEC') or die('Restricted access');

class modSIMAnswers_HeadboardBanners {
	/* Banners Functions - Start */
	function askBanner($option, $view) {
		if ($option != 'com_simanswers' || ($option == 'com_simanswers' && $view != 'ask'))
			modSIMAnswers_HeadboardBanners::askBannerForm();
		elseif ($view == 'ask')
			modSIMAnswers_HeadboardBanners::askBannerDesc();
	}
	function askBannerForm() {
		$document =& JFactory::getDocument();
		$saConfig = SAHelper::getConfig();
		$js = "
		window.addEvent('domready', function() {
			if (!$('sahb-ask-title').value.trim() || $('sahb-ask-title').value == SA_ASK_TITLE_DEFAULT) $('sahb-ask-title').addClass('blurfield');
			$('sahb-ask-form').addEvent('submit', function(e) {
				if (!$('sahb-ask-title').value.trim() || $('sahb-ask-title').value == SA_ASK_TITLE_DEFAULT) {
					e.stop();
					$('sahb-ask-title').setStyle('border-color', '#CC0000');
					$('sahb-ask-title').focus();
				}
			});
		});";
		$document->addScriptDeclaration($js);
	?>
		<li id="sahb-banner-ask">
			<form id="sahb-ask-form" action="<?php echo SALink::submitAsk(1);?>" method="post">
				<div>
					<h2><a href="<?php echo SALink::ask();?>"><?php echo JText::_('SA_HEAD_ASK');?></a></h2>
					<input type="text" id="sahb-ask-title" name="title" maxlength="<?php echo $saConfig->qnmaxlength;?>" class="inputbox" value="<?php echo JText::_('SA_ASK_TITLE_DEFAULT');?>" />
					<input type="submit" class="button" name="Submit" value="<?php echo JText::_('SA_ASK_CONTINUE_BTN');?>" />
				</div>
			</form>
		</li>
	<?php
	}
	function askBannerDesc() {
	?>
		<li id="sahb-banner-ask">
			<form action="<?php echo SALink::submitAsk(1);?>" method="post">
				<div>
					<h2><a href="<?php echo SALink::ask();?>"><?php echo JText::_('SA_HEAD_ASK');?></a></h2>
					<p><?php echo JText::_('SA_HEAD_ASK_DESC');?></p>
				</div>
			</form>
		</li>
	<?php
	}
	
	function answerBanner($option, $view) {
		if ($option != 'com_simanswers' || ($option == 'com_simanswers' && ($view == '' || $view == 'frontpage')))
			modSIMAnswers_HeadboardBanners::answerBannerFull();
		else
			modSIMAnswers_HeadboardBanners::answerBannerClean();
	}
	function answerBannerFull() {
		$catid = JRequest::getVar('catid', 0);
	?>
		<li id="sahb-banner-answer">
			<form action="<?php echo SALink::category($catid, 'answer');?>" method="post">
				<div>
					<h2><a href="<?php echo SALink::category($catid, 'answer');?>"><?php echo JText::_('SA_HEAD_ANSWER');?></a></h2>
					<p><?php echo JText::_('SA_HEAD_ANSWER_DESC');?></p>
					<input type="submit" class="button" value="<?php echo JText::_('SA_HEAD_ANSWER_BTN');?>" />
				</div>
			</form>
		</li>
	<?php
	}
	function answerBannerClean() {
		$catid = JRequest::getVar('catid', 0);
	?>
		<li id="sahb-banner-answer">
				<div>
					<h2><a href="<?php echo SALink::category($catid, 'answer');?>"><?php echo JText::_('SA_HEAD_ANSWER');?></a></h2>
				</div>
		</li>
	<?php
	}
	
	function discoverBanner($option, $view) {
		if ($option != 'com_simanswers' || ($option == 'com_simanswers' && ($view == '' || $view == 'frontpage')))
			modSIMAnswers_HeadboardBanners::discoverBannerFull();
		else
			modSIMAnswers_HeadboardBanners::discoverBannerClean();
	}
	function discoverBannerFull() {
		$catid = JRequest::getVar('catid', 0);
	?>
		<li id="sahb-banner-discover">
			<form action="<?php echo SALink::category($catid, 'discover');?>" method="post">
				<div>
					<h2><a href="<?php echo SALink::category($catid, 'discover');?>"><?php echo JText::_('SA_HEAD_DISCOVER');?></a></h2>
					<p><?php echo JText::_('SA_HEAD_DISCOVER_DESC');?></p>
					<input type="submit" class="button" value="<?php echo JText::_('SA_HEAD_DISCOVER_BTN');?>" />
				</div>
			</form>
		</li>
	<?php
	}
	function discoverBannerClean() {
		$catid = JRequest::getVar('catid', 0);
	?>
		<li id="sahb-banner-discover">
			<div>
				<h2><a href="<?php echo SALink::category($catid, 'discover');?>"><?php echo JText::_('SA_HEAD_DISCOVER');?></a></h2>
			</div>
		</li>
	<?php
	}
	/* Banners Functions - End */
}
?>