<?php
/**
// Copyright (C) 2010 - 2012 Mike Feng Jinglong
//
// This program is a commercial software; you cannot redistribute it
// and/or modify it without the explicit consent from the author.
//
// All title and copyright in and to the Product is owned by Mike Feng
// and is protected by international copyright laws and treaty provisions.
// Mike Feng retains all ownership rights in the Product.
// The copyright notice must be reproduced and included on any copy
// that is expressly permitted under this Agreement.
**/

// no direct access

defined('_JEXEC') or die('Restricted access');

class modSIMAnswersQuestionsHelper {
	function init($option) {
		$document =& JFactory::getDocument();
		$saConfig = SAHelper::getConfig();
		if ($option == 'com_simanswers') {
			if (!$saConfig->mtupgrade) {
				$parameter_script = 'scripts';
				$headerstuff = $document->getHeadData();
				reset($headerstuff[$parameter_script]);
				foreach ($headerstuff[$parameter_script] as $key=>$value){
					if (substr_count($key, 'mootools') > 0)
						unset($headerstuff[$parameter_script][$key]);
				}
				$document->setHeadData( $headerstuff );
			}
		}
		else {
			JHTML::_('behavior.mootools');
			if (file_exists(JPATH_SITE.'/components/com_simanswers/globals.simanswers.php')) {
				require_once(JPATH_SITE.'/components/com_simanswers/globals.simanswers.php');
				require_once(JPATH_SITE.'/components/com_simanswers/integrate.simanswers.php');
			}
			else echo 'Install SIMAnswers component first.';
		}
		//JHTMLBehavior::tooltip('.saqn-hasTip', array('maxTitleChars'=>50, 'className'=>'saqntool', 'hideDelay'=>2500, 'offsets'=>array('x'=>-50, 'y'=>20)));
		if (!defined('_SAQN_TOOLTIP')) {
			$loadready = (eregi("chrome", $_SERVER['HTTP_USER_AGENT'])) ? 'load' : 'domready';
			$fixed = ($saConfig->mtupgrade) ? 'false' : 'true';
			$js = "
			window.addEvent('$loadready', function() {
				if (MooTools.version.substr(0,3) == '1.2') {
					$$('.saqn-hasTip').each(function(element,index) {  
						var title = element.getProperty('title');
						if (title == null) return;
						var content = title.split('::');  
						element.store('tip:title', content[0]);  
						element.store('tip:text', content[1]);
					}); 
				} 
				var SAQnTips = new Tips($$('.saqn-hasTip'), { maxTitleChars: 50, className: 'saqntool', hideDelay:2500, offsets: {x:-50, y:20}, fixed: $fixed});
				$$('.saqntool').setStyle('display', 'none');
				document.addEvent('click', function(e) {
					$$('.saqntool-tip').setStyle('visibility', 'hidden');
					$$('.saqntool').setStyle('display', 'none');
				});
				$$('.saqntool-tip').addEvent('mouseleave', function(e) {
					this.setStyle('visibility', 'hidden');
				});
				$$('.saqntool').addEvent('mouseleave', function(e) {
					this.setStyle('display', 'none');
				});
			});";
			$document->addScriptDeclaration($js);
			define('_SAQN_TOOLTIP', 1);
		}
		$css = JURI::root().'modules/mod_simanswers_questions/assets/mod_simanswers_questions.css';
		$document->addStyleSheet( $css, 'text/css');
	}

	function getQuestions($params) {
		$db =& JFactory::getDBO();
		if (!$params->get('qn_type')) {
			$query = "SELECT * FROM #__simanswers_questions AS q"
				. "\n LEFT JOIN #__simanswers_categories AS c ON q.catid=c.id"
				. "\n WHERE c.published=1";
			$orderby = "\n ORDER BY q.qid DESC";
		}
		elseif ($params->get('qn_type')) {
			$query = "SELECT q.*, COUNT(s.qid) AS stars FROM #__simanswers_stars AS s"
				. "\n LEFT JOIN #__simanswers_questions AS q ON s.qid=q.qid"
				. "\n LEFT JOIN #__simanswers_categories AS c ON q.catid=c.id"
				. "\n WHERE c.published=1";
			$orderby = "\n GROUP BY s.qid ORDER BY stars DESC, s.cdate DESC";
		}
		switch ($params->get('qn_status')) {
			case 0:
				//all
				break;
			case 1:
				//open
				$query .= " AND q.resolved=0 AND q.put_to_vote=0";
				break;
			case 2:
				//resolved
				$query .= " AND q.resolved=1";
				break;
			case 3:
				//undecided
				$query .= " AND q.resolved=0 AND q.put_to_vote=1";
				break;
		}
		if ($params->get('catids')) {
			$cats = explode(',', $params->get('catids'));
			$query .= " AND (q.catid=".$cats[0];
			for ($i=1; $i<count($cats); $i++) {
				$query .= " OR q.catid=".$cats[$i];
			}
			$query .= ")";
		}
		if ($params->get('userids')) {
			$users = explode(',', $params->get('userids'));
			$query .= " AND (q.creator=".$users[0];
			for ($i=1; $i<count($users); $i++) {
				$query .= " OR q.creator=".$users[$i];
			}
			$query .= ")";
		}
		$query .= $orderby." LIMIT ".$params->get('qn_num', 5);
		
		$db->setQuery( $query );
		$questions = $db->loadObjectList();
		return $questions;
	}

	function showMeta($qn, $params) {
		if ( !$params->get('meta_stars') && !$params->get('meta_incategory') && !$params->get('meta_askedby') && !$params->get('meta_count') && !$params->get('meta_timeago') && !$params->get('meta_status') ) return;
		$db =& JFactory::getDBO();
		$return = '<ul class="saqn-meta">';
		if ($params->get('meta_stars')) {
			$db->setQuery( "SELECT * FROM #__simanswers_stars WHERE `qid`=$qn->qid ORDER BY `cdate` DESC" );
			$stars = $db->loadObjectList();
			$starcount = (count($stars) > 0) ? count($stars) : '';
			$starclass = (count($stars) > 0) ? 'saqn-star-rated' : 'saqn-star-none';
			$return .= '
			<li class="saqn-meta-star">
				<div class="saqn-star-count">'.$starcount.'</div><div class="'.$starclass.'">&nbsp;</div>
			</li>
			';
		}
		if ($params->get('meta_incategory')) $return .= '<li>'.JText::_('SA_META_IN').' <a href="'.SALink::category($qn->catid).'">'.modSIMAnswersQuestionsHelper::getCategoryName($qn->catid).'</a> - </li>';
		if ($params->get('meta_askedby')) $return .= '<li>'.JText::_('SA_META_ASKED_BY').' <a href="'.SALink::dashboard($qn->creator).'">'.SAHelper::getDisplayName($qn->creator).'</a> - </li>';
		if ($params->get('meta_count')) {
			$db->setQuery( "SELECT COUNT(*) FROM #__simanswers_answers WHERE `qid`=$qn->qid" );
			$answercount = $db->loadResult();
			$return .= '<li>'.$answercount.' '.JText::_('SA_META_ANSWSERS').' - </li>';
		}
		if ($params->get('meta_timeago')) $return .= '<li>'.modSIMAnswersQuestionsHelper::getTimeAgo($qn->cdate).'</li>';
		if ($params->get('meta_status')) {
			if ($qn->resolved) $status = JText::_('SA_META_RESOLVED');
			elseif ($qn->put_to_vote) $status = JText::_('SA_META_IN_VOTING');
			else $status = JText::_('SA_META_OPEN');
			$return .= '<li> - '.$status.'</li>';
		}
		$return .= '</ul>';
		return $return;
	}

	function getCategoryName($catid) {
		$db =& JFactory::getDBO();
		$cat = new SACategory($db);
		$cat->load($catid);
		return $cat->name;
	}

	function getTimeAgo($ago) {
		$seconds = time() - $ago;
		if ($seconds < 60)
			return $seconds.' '.JText::_('SA_TIME_SECONDS').' '.JText::_('SA_TIME_AGO');
		$minutes = floor($seconds / 60);
		if ($minutes < 60)
			return $minutes.' '.JText::_('SA_TIME_MINUTES').' '.JText::_('SA_TIME_AGO');
		$hours = floor($minutes / 60);
		if ($hours < 24)
			return $hours.' '.JText::_('SA_TIME_HOURS').' '.JText::_('SA_TIME_AGO');
		$days = floor($hours / 24);
		if ($days < 7)
			return $days.' '.JText::_('SA_TIME_DAYS').' '.JText::_('SA_TIME_AGO');
		$weeks = floor($days / 7);
		if ($weeks < 5)
			return $weeks.' '.JText::_('SA_TIME_WEEKS').' '.JText::_('SA_TIME_AGO');
		$months = floor($days / 30);
		return $months.' '.JText::_('SA_TIME_MONTHS').' '.JText::_('SA_TIME_AGO');
	}
}
?>