<?php
/**
// Copyright (C) 2009 - 2011 Mike Feng Jinglong
//
// This program is a commercial software; you cannot redistribute it
// and/or modify it without the explicit consent from the author.
//
// All title and copyright in and to the Product is owned by Mike Feng
// and is protected by international copyright laws and treaty provisions.
// Mike Feng retains all ownership rights in the Product.
// The copyright notice must be reproduced and included on any copy
// that is expressly permitted under this Agreement.
**/

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once( JPATH_SITE . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'core.php');
require_once(JPATH_SITE.'/components/com_simanswers/globals.simanswers.php');
require_once(JPATH_SITE.'/components/com_simanswers/integrate.simanswers.php');
JPlugin::loadLanguage( 'com_simanswers' );

class plgCommunitySIMAnswers extends CApplications {
	var $name		= 'SIMAnswers';
	var $_name		= 'simanswers';
	var $_user		= null;

	function plgCommunitySIMAnswers(& $subject, $config) {
		$this->_user	=& CFactory::getActiveProfile();
		$this->_my		=& CFactory::getUser();
		$this->db		=& JFactory::getDBO();
	
		parent::__construct($subject, $config);
	}
	
	function onSystemStart() {
		global $saurlraw;
		JHTML::_( 'behavior.mootools' );
		JHTML::_( 'behavior.modal' );
		$saurlraw = JURI::root().$saurlraw;
		if(!class_exists('CFactory'))
			require_once(JPATH_ROOT . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'core.php');
		$toolbar =& CFactory::getToolbar();
		$toolbar->addGroup('SIMANSWERS', JText::_('SA_PLG_ANSWERS'), SALink::frontpage());
		if (!$this->_my->guest && $this->_my->id == $this->_user->id)
			$toolbar->addItem('SIMANSWERS', 'SIMANSWERS_ASK', JText::_('SA_PLG_ASK_QUESTION'), "SqueezeBox.fromElement(this, {'handler': 'url', 'url': '{$saurlraw}&view=plugin', 'size': {x:450, y:100} })", 'append', true);
		$caption = ($this->_my->id == $this->_user->id) ? JText::_('SA_PLG_MY_DASHBOARD') : JText::_('SA_PLG_DASHBOARD');
		$toolbar->addItem('SIMANSWERS', 'SIMANSWERS_QNA', $caption, SALink::dashboard($this->_user->id, 'qna'));
	}
	
	/**
	 * Ajax function to save a new wall entry
	 * 	 
	 * @param message	A message that is submitted by the user
	 * @param uniqueId	The unique id for this group
	 * 
	 **/	 	 	 	 	 		
	function onProfileDisplay() {	
		global $saurlraw;
		$this->loadUserParams();
 
		$uri = JURI::base();
		$my =& JFactory::getUser();
		$user =& CFactory::getActiveProfile();
		$document =& JFactory::getDocument();
		$css = $uri.'plugins/community/simanswers/style.css';
		$document->addStyleSheet($css);	
 
		$username = $this->params->get('username');
		$password = $this->params->get('password');
 
		$cache =& JFactory::getCache('community');
		$callback = array($this, '_getOutputHTML');
 
		$content = $cache->call($callback, $username, $password, $this->params, $user, $my);
		return $content; 
	}

	function _getOutputHTML($username, $password, &$params, &$user, &$my) {
		ob_start();
		SAHelper::files('dashboard');
		$this->db->setQuery( "SELECT * FROM #__simanswers_questions WHERE `creator`=$user->id ORDER BY `qid` DESC" );
		$qns = $this->db->loadObjectList();
		$this->db->setQuery( "SELECT * FROM #__simanswers_answers WHERE `creator`=$user->id ORDER BY `aid` DESC" );
		$answers = $this->db->loadObjectList();
		dashboardQnA($user->id, $qns, $answers, true);
		?>
		<script type="text/javascript">
		window.addEvent('domready', function() {

			SqueezeBox.initialize({});

			$$('a.modal').each(function(el) {
				el.addEvent('click', function(e) {
					new Event(e).stop();
					SqueezeBox.fromElement(el);
				});
			});
		});
		</script>
		<?php
		$contents = ob_get_contents();
		@ob_end_clean();
		
		return $contents;
	}
}
?>