<?php
/**
// Copyright (C) 2010 - 2012 Mike Feng Jinglong
//
// This program is a commercial software; you cannot redistribute it
// and/or modify it without the explicit consent from the author.
//
// All title and copyright in and to the Product is owned by Mike Feng
// and is protected by international copyright laws and treaty provisions.
// Mike Feng retains all ownership rights in the Product.
// The copyright notice must be reproduced and included on any copy
// that is expressly permitted under this Agreement.
**/
 
// no direct access
defined('_JEXEC') or die('Restricted access');
jimport('joomla.event.plugin');

class plgSystemSIMAnswers_system extends JPlugin {
	var $_landingoption		= null;

	function plgSystemSIMAnswers_system(& $subject, $config) {
		parent::__construct($subject, $config);
	}
	
	function onAfterInitialise() {
		global $mainframe;
		if ($mainframe->isAdmin()) return true;
		JPlugin::loadLanguage( 'com_simanswers' );
	}
	
	function onAfterRoute() {
		global $mainframe;
		if ($mainframe->isAdmin()) return true;
		require_once(JPATH_SITE."/components/com_simanswers/globals.simanswers.php");
		require_once(JPATH_SITE."/components/com_simanswers/integrate.simanswers.php");
		$db =& JFactory::getDBO();
		$my =& JFactory::getUser();
		$option = JRequest::getVar('option', '');
		
		if ($option == 'com_community') { //add style for sa-activity-qn
			$document =& JFactory::getDocument();
			$css = "
			.sa-activity-qn {
				padding: 0px 0px 0px 20px;
				margin: 3px 0px 0px 8px;
				background: url(".JURI::root()."components/com_simanswers/images/activity-quotes.png) 0px 0px no-repeat;
				color: #808080;
			}";
			$document->addStyleDeclaration($css);
		}
	
		//check if user is visiting within 24 hours
		if (!$my->guest) {
			$db->setQuery( "SELECT COUNT(*) FROM #__simanswers_points WHERE `uid`=$my->id AND `reason`='login' AND `cdate`>".(time()-86400) );
			$lastvisit = (int)$db->loadResult();
			if ($lastvisit == 0) {
				$points = new SAPoints($db);
				$points->uid = $my->id;
				$points->points = $saConfig->points['login'];
				$points->cdate = time();
				$points->reason = 'login';
				$points->setpoints();
			}
		}
		
		//check for expired questions and see if there are any answers. If not, remove.
		$db->setQuery( "SELECT * FROM #__simanswers_questions AS q WHERE q.resolved=0 AND q.expiration<".time()." AND (SELECT COUNT(*) FROM #__simanswers_answers AS a WHERE a.qid=q.qid)=0" );
		$rows = $db->loadObjectList();
		foreach ($rows as $row) {
			$points = new SAPoints($db);
			$points->uid = $row->creator;
			$points->qid = $row->qid;
			$points->points = $saConfig->points['ask'] * -1;
			$points->cdate = time();
			$points->reason = 'expired';
			$points->setpoints();
			SAHelper::deleteQuestion($row->qid);
		}
		
		//check for expired, unresolved and non-voting questions and put them to vote
		$db->setQuery( "UPDATE #__simanswers_questions SET `put_to_vote`=1 WHERE `expiration`<".time()." AND `put_to_vote`=0 AND `resolved`=0" );
		$db->query();
		
		//check for put to vote questions that are expired, and see if there is an answer with 2 more votes
		$db->setQuery( "SELECT * FROM #__simanswers_questions WHERE `resolved`=0 AND `put_to_vote`=1 AND `expiration`<".time() );
		$qns = $db->loadObjectList();
		foreach ($qns as $qn) {
			$expire = false;
			$query = "SELECT DISTINCT v.aid, (SELECT COUNT(*) FROM #__simanswers_votes WHERE `aid`=v.aid && `qid`=$qn->qid) AS votecount FROM #__simanswers_votes AS v WHERE v.qid=$qn->qid ORDER BY votecount DESC LIMIT 2";
			$db->setQuery($query);
			$answers = $db->loadObjectList();
			
			if (!count($answers)) $expire = true; //if no answers, expire
			elseif (count($answers) == 1) { //if only 1 answer
				//if votecount less than voteslead, expire
				if ($answers[0]->votecount < $saConfig->voteslead) $expire = true;
				//else (votecount >= voteslead) if only answer is "No Best Answer", expire
				elseif ($answers[0]->aid == 0) $expire = true;
			}
			elseif (count($answers) >= 2) { //if 2 or more answers
				//if votecount >= voteslead, and winner is a "No Best Answer", expire
				if ($answers[0]->aid == 0 && ($answers[0]->votecount - $answers[1]->votecount) >= $saConfig->voteslead) $expire = true;
			}
			//if expire, bye bye and continue to next loop
			if ($expire) {
				$points = new SAPoints($db);
				$points->uid = $qn->creator;
				$points->qid = $qn->qid;
				$points->points = $saConfig->points['ask'] * -1;
				$points->cdate = time();
				$points->reason = 'expired';
				$points->setpoints();
				SAHelper::deleteQuestion($qn->qid);
				continue;
			}
			//else if there is a winner (non-expire)
			elseif ($answers[0]->votecount - $answers[1]->votecount >= $saConfig->voteslead) {
				//update question as resolved
				$db->setQuery( "UPDATE #__simanswers_questions SET `resolved`=1 WHERE `qid`=$qn->qid" );
				$db->query();
				//update answer as best=2 (voted)
				$db->setQuery( "UPDATE #__simanswers_answers SET `best`=2 WHERE `aid`=".$answers[0]->aid );
				$db->query();
				//give points to answerer
				$thisanswer = new SAAnswer($db);
				$thisanswer->load($answers[0]->aid);
				$points = new SAPoints($db);
				$points->uid = $thisanswer->creator;
				$points->qid = $qn->qid;
				$points->points = $saConfig->points['bestanswer'];
				$points->cdate = time();
				$points->reason = 'bestanswer';
				$points->setpoints();
			}
			//the rest will wait for tie breaker
			
		}
	}
}
?>